' m.spin ... a slightly modified mandelbrot-20140623-fds-80x25.spin
'-------------------------------------------------------------------------------
con
  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

  xmin=round(-2.1*float(4096))
  xmax=round( 0.7*float(4096))

  ymin=round(-1.2*float(4096))
  ymax=round( 1.2*float(4096))

  maxiter=25

obj
  ser : "FullDuplexSerial"

pub main | c,cx,cy,dx,dy,x,y,xn,yn,rsq,iter,t

  ser.start(31, 30, 0, 115200)

  t:=cnt

  dx:=(xmax-xmin)/79
  dy:=(ymax-ymin)/24

  cy:=ymin
  repeat while cy=<ymax
    cx:=xmin
    repeat while cx=<xmax
      x:=0
      y:=0
      rsq:=0
      iter:=0
      repeat while iter=<maxiter and rsq=<16384
        xn:=((x*x-y*y)~>12)+cx
        yn:=((x*y)~>11)+cy
        x:=xn
        y:=yn
        rsq:=(x*x+y*y)~>12
        iter+=1
      cx+=dx
      ser.tx(iter+32)
    cy+=dy
    ser.tx(10)

  t:=cnt-t

  ser.tx(10)
  ser.dec(t)
  ser.str(string(" ticks",10,10))

  waitcnt(_clkfreq>>2+cnt)
  ser.stop
